-- Warcraft III Plugin
-- written by MiroslavR
-- 2009

-- USE THIS SCRIPT ON YOUR OWN!
-- AUTHOR IS NOT RESPONSIBLE FOR ANY DAMAGES CAUSED BY USING THIS SCRIPT
-- YOU GOT NO RIGHT TO STEAL THIS SCRIPT

-- Setup an array
function initArray(m)
	local array = {}
	for i = 1, m do
		array[i]=0
	end
	return array
end

-- Setup and fill array with "f"
function initArray2(m, f)
	local array = {}
	for i = 1, m do
		array[i]=f
	end
	return array
end


function get_pairs(array)
	local test = 0
	for i in ipairs(array) do
		test = test + 1
	end
	return test
end

function part_words(txt2, amount)
	local word = {}
	local success = 1
	for l in string.gmatch(txt2, "%w+") do
		table.insert(word, l)
	end		
	
	for i=1, amount do
		if (word[i] == "") or (word[i]==nil) then
			success = 0
		end		
	end
	
	if (success == 0) then
		return 0
	else
		return word
	end
	
end

function col(r, g, b)
	final = ""
	local lol2 = initArray(3)
	
	for i=1, 3 do
		if (i==1) then lol2[i] = r end
		if (i==2) then lol2[i] = g end
		if (i==3) then lol2[i] = b end
		
		if (string.len(lol2[i]) ~= 3) then
			if (string.len(lol2[i])==2) then
				lol2[i] = "0"..lol2[i]
			elseif (string.len(lol2[i])==1) then
				lol2[i] = "00"..lol2[i]
			end
		end
		final = final..lol2[i]	
	end
	return final
	
end

-- Setup randomize seed
math.randomseed( os.time() )
math.random(); math.random(); math.random()

-- Setup table file saving & loading
-- dofile("sys/lua/miroslavr/table_save.lua")

function mocnina(a, num)
	final = a
	for i=1, num-1 do
		final = final * a
	end
	return final
end

max_players = 32

w3_version = "0.1.7a"

pl_class = initArray(max_players)
pl_immobile = initArray(max_players)
max_classes = 9
pl_classes = {"Undead Scourge", "Human Alliance", "Orcish Horde", "Night Elf of Kalimdore", "Blood Mage", "Shadow Hunter", "Warden", "Crypt Lord", "Random ? ? ?"}
pl_info = {"", "", "", "", "", "", "", "", ""}

pl_xp = initArray(max_players)
pl_maxxp = initArray2(max_players, 20)
pl_level = initArray2(max_players, 1)

pl_items = {"Boots of Speed", "Claws of Attack", "Cloak of Shadows", "Mask of Death", "Orb of Frost", "Periapt of Health", "Scroll of Respawning", "Flaming Gloves of Warmth", "Mole", "Tome of Experience", "Ring of Regeneration", "Necklace of Immunity"}
max_items = get_pairs(pl_items)

pl_items_info = {"Are the special boots which increase your speed after applying them", "If you got this, an additional damage will be removed from the enemy on every hit", "Makes you partially invisible", "You will receive health for every hit on the enemy", "Slows your enemy down when you hit him", "Receive extra health", "You will respawn after death", "You will be given a nade every 10 seconds", "You will spawn near the random enemy", "Adds additional XP to you", "A ring which adds you (2*number of rings) hp every second, you can buy 5 rings", "Makes you immune to all enemy ultimates"}

pl_items_money = {"4000", "1500", "8000", "1200", "3500", "1000", "2000", "4000", "16000", "5000", "2000", "10000"}

pl_clawsofattack = initArray(max_players)
pl_maskofdeath = initArray(max_players)
pl_scrollofrespawning = initArray(max_players)
pl_flaminggloves = initArray(max_players)
pl_flaminggloves2 = initArray(max_players)
pl_getmole = initArray(max_players)
pl_orboffrost = initArray(max_players)
pl_carrionbeetles = initArray(max_players)
pl_locustswarm = initArray(max_players)
pl_lightning = initArray(max_players)
pl_entangleroots = initArray(max_players)
pl_gotentangleroots = initArray(max_players)
pl_necklaceofimmunity = initArray(max_players)
pl_slowenemy = initArray(max_players)
pl_randomclass = initArray(max_players)
pl_nextclass = initArray(max_players)
pl_immortal = initArray(max_players)
pl_mute = initArray(max_players)
pl_noob = initArray(max_players)
pl_ringofregeneration = initArray(max_players)
pl_flamestrike = initArray(max_players)
pl_blink = initArray(max_players)
pl_voted = initArray(max_players)
pl_allow_ultimates = initArray2(max_players, 1)

spawnx = initArray(max_players)
spawny = initArray(max_players)

sound_path = "wc3tft_2d/"

camp_detect = 0


help_other = {"wc3", "wc3tft", "wc3tft_2d", "plugin", "ultimate", "shopmenu", "race", "class", "xp", "level"}
help_other_info = {"Wacraft III", "Warcraft III The Frozen Throne", "Warcraft III The Frozen Throne 2D", "This is a script for CS2D made by MiroslavR, which offers you to play WC3TFT in 2D!", "Ultimate is very important ability (super power) of a specific class", "When you're in a buy zone, you'll be able to buy items by pressing F4 or writing !shopmenu", "A class", "Class is a special person (you can choose it) with specific attributes, you can also play with no class", " = experience", "A state of player, after gaining a level, you will be given something"}

pl_powers = {"Suicide Bomber", "", "Immobile", "", "Lightning Bolt", "", "Entangle Roots", "", "Teammate reviving", "Flame Strike", "Slow Enemy", "", "Poisonous Knife", "Blink", "Carrion Beetles", "Locust Swarm"}


pl_bot_use_carrion_beetles = initArray(max_players)
pl_bot_use_locust_swarm = initArray(max_players)
pl_bot_use_slowenemy = initArray(max_players)
pl_bot_use_entangleroots = initArray(max_players)

pl_bot_buy_time = initArray(max_players)

pl_respawnonce = initArray(max_players)
pl_poisoned = initArray(max_players)
pl_poisoned_owner = initArray(max_players)
pl_flamed = initArray(max_players)
pl_flamed_owner = initArray(max_players)

-- Server settings, can be changed ingame

carrion_beetles_deploy_chance = 60
carrion_beetles_poison_chance = 50
slow_enemy_deploy_chance = 100
entangle_roots_deploy_chance = 100
locust_swarm_deploy_chance = 80
lightning_bolt_radius = 4
poison_time = 4

player_immobile_time = 3
player_entangle_roots_time = 10

bot_use_carrion_beetles_start_time = 4
bot_use_carrion_beetles_end_time = 8
bot_use_locust_swarm_start_time = 8
bot_use_locust_swarm_end_time = 12
bot_use_entangle_roots_start_time = 2
bot_use_entangle_roots_end_time = 12
bot_use_slow_enemy_start_time = 2
bot_use_slow_enemy_end_time = 12
bot_use_lightning_bolt_chance = 100
bot_use_flame_strike_chance = 100
bot_buy_start_time = 1
bot_buy_end_time = 2

carrion_beetles_damage = 60
locust_swarm_damage = 40

impale_chance = 50
impale_intensity = 82

poison_damage = 15
flame_damage = 20

immobile_chance = 30

suicide_bomber_range = 125
suicide_bomber_power = 250

tome_of_experience_addxp = 25

flame_strike_radius = 5
blink_radius = 4

unlock_carrion_beetles_level = 6
unlock_locust_swarm_level = 5
unlock_entangle_roots_level = 5
unlock_slow_enemy_level = 4
unlock_teammate_revealing_level = 3
unlock_poisonous_knife_level = 3
unlock_suicide_bomber_level = 2
unlock_immobiling_level = 3
unlock_lightning_level = 4
unlock_flame_strike_level = 5
unlock_blink_level = 3

mole_chance = 40



class_menu_content = ""
class_menu_content2 = ""
buy_menu_content = ""
buy_menu_content2 = ""

camp_reasons = {"Palm camping", "Tree camping"}
change_values={"carrionbeetlesdeploychance", "carrionbeetlespoisonchance", "slowenemydeploychance", "entanglerootsdeploychance", "locustswarmdeploychance", "lightningboltradius", "poisontime", "playerimmobiletime", "playerentanglerootstime", "botusecarrionbeetlesstarttime", "botusecarrionbeetlesendtime", "botuselocustswarmstarttime", "botuselocustswarmendtime", "botuseentanglerootsstarttime", "botuseentanglerootsendtime", "botuseslowenemystarttime", "botuseslowenemyendtime", "botuselightningboltchance", "carrionbeetlesdamage", "locustswarmdamage", "impalechance", "impaleintensity", "poisondamage", "suicidebomberrange", "suicidebomberpower", "tomeofexperienceaddxp", "immobilechance", "flamedamage", "flamestrikeradius", "blinkradius", "unlockcarrionbeetles_evel", "unlocklocustswarmlevel", "unlockentanglerootslevel", "unlockslowenemylevel", "unlockteammaterevealinglevel", "unlockpoisonousknifelevel", "unlocksuicidebomberlevel", "unlockimmobilinglevel", "unlocklightninglevel", "unlockflame_strikelevel", "unlockblinklevel", "molechance"}

os.execute("mkdir wc3_data")

--Thanks to Kiffer-Opa for weapon IDs

USP     	= 1
Glock   	= 2
Deagle		= 3
P228		= 4
Elite		= 5
FiveSeven	= 6

M3		=10
XM1014		=11

MP5		=20
TMP		=21
P90		=22
Mac10		=23
UMP45		=24

Galil		=38
Famas		=39
AK47		=30
M4A1		=32
SG552		=31
Aug		=33
Scout		=34
AWP		=35
G3SG1		=36
SG550		=37

M249		=40

PrimaryAmmo	=61
SecondaryAmmo	=62

HE		=51
Flashbang	=52
SmokeGrenade	=53
Flare		=54
DefuseKit	=56
Kevlar		=57
KevlarHelm	=58
NightVision	=59
TacticalShield	=41

Bomb	=55
PlantedBomb	=63

Knife 		=50
Machete		=69
Wrench		=74
Claw		=78
Chainsaw	=85

GasGrenade	=72
MolotovCocktail	=73
Snowball	=75
AirStrike	=76
GutBomb		=86

Mine		=76

Laser		=45

Flamethrower	=46

RPGLauncher	=47
RocketLauncher	=48
GrenadeLauncher	=49

LightArmor	=79
Armor		=80
HeavyArmor	=81
SuperArmor	=83
MedicArmor	=82

StealthSuit	=84

Medikit		=64
Bandage		=65

Coins		=66
Money		=67
Gold		=68

RedFlag		=70
BlueFlag	=71

a_LightArmor	= 79
a_Armor		= 80
a_HeavyArmor	= 81
a_SuperArmor	= 83
a_MedicArmor	= 82
a_StealthSuit	= 84


-- END of weapon IDs --

dofile("sys/lua/miroslavr/wc3tft_functions.lua")
dofile("sys/lua/miroslavr/wc3tft_hooks.lua")


player_load_all()

--Fix old (broken) saves
for i=1, max_players do
	if player(i, "exists") then
		if player(i, "usgn")>0 then
			if (pl_level[i]>7) then	
				pl_level[i]=7
				pl_xp[i]=1337
				pl_maxxp[i]=1337
				save_settings(i)
				print(col(0, 255, 255).."Fixing "..player(i, "name").."'s level...")
			elseif (pl_level[i]<1) then	
				player_setlevel(i, 1)
			end
			
			
			if (pl_xp[i]<0) or (pl_xp[i]>pl_maxxp[i]) then
				pl_xp[i]=0
				save_settings(i)
				print(col(0, 255, 255).."Fixing "..player(i, "name").."'s XP...")
			end
			
			if (pl_maxxp[i]<0) or (pl_maxxp[i]<pl_xp[i]) then
				pl_maxxp[i]=10*mocnina(2, pl_level[i])
				save_settings(i)
				print(col(0, 255, 255).."Fixing "..player(i, "name").."'s Max XP...")
			end		
		end	
	end
end


for i=1, max_classes-(max_classes-9) do
	if (i<max_classes) then
		class_menu_content = class_menu_content..""..pl_classes[i].."|"..pl_info[i]..","
	else
		class_menu_content = class_menu_content.."Next >>"
	end
end


for i=max_classes-1, max_classes+(max_classes-9) do
	if (i<max_classes+(max_classes-9)) then
		class_menu_content2 = class_menu_content2..""..pl_classes[i+1].."|"..pl_info[i+1]..","
	else
		class_menu_content2 = class_menu_content2.."<< Previous"	
	end
end

for i=1, 9 do
	if (i<9) then
		buy_menu_content = buy_menu_content..""..pl_items[i].."|".."Costs "..tostring(pl_items_money[i])..","	
	else
		buy_menu_content = buy_menu_content.."Next >>"
	end
end

for i=1, max_items-8+1 do
	page = (max_items-8)
	if (i<=page) then
		buy_menu_content2 = buy_menu_content2..""..pl_items[i+8].."|".."Costs "..tostring(pl_items_money[i+8])..","	
	else
		buy_menu_content2 = buy_menu_content2.."<< Previous"
	end
end
