function player_setlevel(id, level)
	if player(id, "exists") then
		if (level>=1) and (level<=7) then
			maxxp = 10*mocnina(2,level)
			pl_level[id]=level
			pl_xp[id]=0
			pl_maxxp[id]=maxxp
			hud_pl_update(id)
			save_settings(id)
		end
	end
end

function player_teammate_revive(id)
	if player(id, "exists") then
		local lol = 0
		for k=1, max_players do
			if player(k, "exists") then
				if (k~=id) then
					if (player(k, "team")==player(id, "team")) then
						if player(k, "health")<1 then
							lol = lol + 1
						end
					end
				end
			end
		end
		
		if (lol>0) then
			teammate = math.random(1, max_players)
			while ((not(player(teammate, "exists"))) or (player(teammate, "team")~=player(id, "team")) or (teammate==id) or (player(teammate, "health")>0))  do
				teammate = math.random(1, max_players)
			end		
			player_respawn(teammate, player(teammate, "x"), player(teammate, "y"))
			msg("000255000"..player(teammate, "name").." has been revived by "..player(id, "name"))
		else
			msg2(id, "255000000There is nobody on your team to revive!")
		end
	end	
end

function player_setxp(id, xp)
	if player(id, "exists") then
		level = pl_level[id]
		maxx = pl_maxxp[id]
		if (level>=1) and (level<=7) then
			local success = 1
			if (xp < maxxp) then
				pl_xp[id]=xp
				pl_maxxp[id]=maxxp
				success = 1
			elseif (xp==maxxp) then
				if (level < 7) then
					player_setlevel(id, level + 1)
				else
					print("255000000Cannot set XP!")
				end
			else
				success = 0
			end
			
			if (success == 1) then
				print("000255000"..player(id, "name").."'s XP has been changed to "..xp.."!")
			else
				print("255000000"..player(id, "name").." has lower XP than "..xp.."!")
			end
			
			hud_pl_update(id)
			save_settings(id)
			
		end
	end
end

function player_gainxp(id, amount)
	if player(id, "exists") then
		level = pl_level[id]
		maxx = pl_maxxp[id]
		if (level>=1) and (level<7) then
			player_experience(id, 1, amount)
			print("000255000"..player(id, "name").."'s gained "..amount.." XP!")
		elseif (level == 7) then
			print("255000000"..player(id, "name").." has already reached the final level!")
		else
			print("255000000Unknown error!")
		end
	end
end


function hud_pl_update(id)
	txt2=""
	txt3=""
	txt4=""
	txt5=""
	local random = 1
	if player(id, "exists") then
		if (player(id, "health") > 0) then
			if (pl_randomclass[id] == 1) then
				if (pl_class[id] > 0) then
					random = 0
				end
			end
		end
	end
		
		if (pl_class[id]==1) then
			txt2="1. Health + after causing a dmg"
			txt3="2. Higher speed"
			txt4="3. Suicide Bomber [LEVEL "..unlock_suicide_bomber_level.." REQUIRED]"
			txt5=""
		elseif (pl_class[id]==2) then
			txt2="1. Partial invisiblity"
			txt3="2. More Health"
			txt4="3. Chance of immobiling a player (by hurting) [LEVEL "..unlock_immobiling_level.." REQUIRED]"	
			txt5=""			
		elseif (pl_class[id]==3) then
			txt2="1. Chance of extra damage"
			txt3="2. HEs always do more dmg"
			txt4="3. Reincarnation"			
			txt5="4. Lightning Bolt (write !lightning) [LEVEL "..unlock_lightning_level.." REQUIRED]"
		elseif (pl_class[id]==4) then
			txt2="1. Additional dmg to person who shot you"
			txt3="2. Extra damage"
			txt4="3. Entangle Roots (write !entangleroots) [LEVEL "..unlock_entangle_roots_level.." REQUIRED]"			
			txt5="(entangleroots selects random player)"
		elseif (pl_class[id]==5) then
			txt2="1. Ability to steal money (by hurting)"
			txt3="2. Chance to revive teammate [LEVEL "..unlock_teammate_revealing_level.." REQUIRED]"
			txt4="(after your death)"		
			txt5="3. Flame Strike [LEVEL "..unlock_flame_strike_level.." REQUIRED]"
		elseif (pl_class[id]==6) then
			txt2="1. Heals yourself and nearby teammates"
			txt3="2. Ability to slow down enemy (write !slowenemy) [LEVEL "..unlock_slow_enemy_level.." REQUIRED]"
			txt4="(slowenemy selects random player)"	
			txt5=""			
		elseif (pl_class[id]==7) then
			txt2="1. Chance of becoming a mole"
			txt3="2. Respawn once with 50 health"
			txt4="3. Poisonous knife [LEVEL "..unlock_poisonous_knife_level.." REQUIRED]"
			txt5="4. Blink (write !blink)[LEVEL "..unlock_blink_level.." REQUIRED]"
		elseif (pl_class[id]==8) then
			txt2="1. Mirror dmg to person who shot you, armor +"
			txt3="2. Carrion Beetles (write !carrionbeetles) [LEVEL "..unlock_carrion_beetles_level.." REQUIRED]"
			txt4="3. Locust Swarm (write !locustswarm), Impale (shakes your enemy) [LEVEL "..unlock_locust_swarm_level.." REQUIRED]"
			txt5="both abilities choose random player"
		elseif (pl_class[id]==9) then
			txt1="? ? ?"
			txt2="Random class on next respawn"
			txt3="? ? ?"
			txt4=""
			txt5=""			
		elseif (pl_class[id]==10) then
			txt2="Not done yet"
			txt3="Please select other class!"
			txt4=""	
			txt5=""
		end

		
	if player(id, "exists") then
		if (pl_class[id]~=nil and pl_classes[pl_class[id]]~=nil) then
			parse('hudtxt2 '..id..' 0 "102255255'..pl_classes[pl_class[id]]..'" 620 80 2')
			parse('hudtxt2 '..id..' 1 "102255102'..txt2..'" 620 95 2')
			parse('hudtxt2 '..id..' 2 "102255102'..txt3..'" 620 110 2')
			parse('hudtxt2 '..id..' 3 "102255102'..txt4..'" 620 125 2')
			parse('hudtxt2 '..id..' 8 "102255102'..txt5..'" 620 140 2')
		else
			parse('hudtxt2 '..id..' 0 "255000000You havent selected any class yet... Press F2!" 620 80 2')
			parse('hudtxt2 '..id..' 1 "" 620 95 2')
			parse('hudtxt2 '..id..' 2 "" 620 110 2')
			parse('hudtxt2 '..id..' 3 "" 620 125 2')
			parse('hudtxt2 '..id..' 8 "" 620 125 2')
		end
			
		if player(id, "health")>0 then
			parse('hudtxt2 '..id..' 4 "255102080WC3TFT_2D v.'..w3_version..'" 320 4 1')
		else
			parse('hudtxt2 '..id..' 4 "255102080WC3TFT_2D v.'..w3_version..'" 320 40 1')
		end
		
		if (pl_level[id]<7) then
			parse('hudtxt2 '..id..' 5 "Experience: '..pl_xp[id]..'/'..pl_maxxp[id]..'" 620 180 2')
			parse('hudtxt2 '..id..' 6 "Level: '..pl_level[id]..'" 620 205 2')
		else
			parse('hudtxt2 '..id..' 5 "" 620 180 2')
			parse('hudtxt2 '..id..' 6 "255080190Final level (7)" 620 205 2')
		end
		
		if player(id, "usgn")<1 then
			parse('hudtxt2 '..id..' 7 "255000000No USGN Login!" 620 300 2')
		else
			parse('hudtxt2 '..id..' 7 "000255000Logged in to USGN - '..player(id, "usgn")..'" 620 300 2')
		end

	end
end


function save_settings(id)
	if player(id, "exists") then
		usgn = player(id, "usgn")
		if (usgn > 0) then

			local file
			file = io.open("wc3_data/"..usgn..".txt", "w")
			if (file ~= nil) then
				file:write("#SETTINGS ")
				file:write(pl_level[id]); file:write(" ")
				file:write(pl_xp[id]); file:write(" ")
				file:write(pl_maxxp[id])
				file:write(string.char(13).." ")
				file:write(player(id, "name")..' "'..player(id, "ip")..'"')
				file:close()
			else
				print("255000000Error: Can't open 'wc3_data/"..usgn..".txt!'")
			end
		end
	end
end

function load_settings(id)
	if player(id, "exists") then
		usgn = player(id, "usgn")
		if (usgn > 0) then
			file = io.open("wc3_data/"..usgn..".txt", "r")
			if (file ~= nil) then
				line = file:read("*a")
				if (line ~= nil) then
					if (string.sub(line, 1, string.len("#SETTINGS "))=="#SETTINGS ") then
						length = string.len("#SETTINGS ")+1
						txt2 = string.sub(line, length)
						if (txt2 ~= nil) then
							local word = {}
							local success = 1
							for l in string.gmatch(txt2, "%w+") do
								table.insert(word, l)
							end
							if ((word[1] == "") or (word[2] == "") or (word[3] == "") or (word[1]==nil) or (word[2]==nil) or (word[3]==nil)) then
								success = 0
							end
							
							if (success == 1) then							
								level = tonumber(word[1])
								xp = tonumber(word[2])
								maxxp = tonumber(word[3])
								pl_level[id] = level
								pl_xp[id] = xp
								pl_maxxp[id] = maxxp
							else
								print("000000255Broken stats of "..player(id, "name").."; reseting...")
								player_setlevel(id, 1)							
							end
						end
					end
				else
					print("255000000Error: Can't open 'wc3_data/"..usgn..".txt!'")					
				end
				file:close()
			end
		end
	end
end

function player_load_all()
	for i=1, max_players do
		if player(i, "exists") then
			load_settings(i)
		end
	end
end

function lolz4(text)
	length = string.len(text)
	spaces = ""
	final = ""
	for i=0, length-1 do
		for p=1, length-i do
			spaces = spaces.." "
		end
		final = spaces..text
		msg(final)
		spaces = ""
		final = ""		
	end
end

function lolz25(type)
	--print(x)
	--print(y)
	for i=1, 50 do
		x = math.random(1, map("xsize"))
		y = math.random(1, map("ysize"))
		parse("spawnobject "..type.." "..x.." "..y.." "..math.random(1, 359).." 1 "..math.random(0, 2))
	end
end


function point_collide(pointx, pointy, x, y, sizex, sizey)
	local over
	if (pointx>=x) and (pointy>=y) then
		if (pointx<=x+sizex) and (pointy<=y+sizey) then
			over = 1
		end
	end
	
	if over then return 1 end
	return 0
end

function player_select_ultimate(id, ult)
	if player(id, "exists") then
		if (ult~=nil) and (ult ~= "") then
			
			if (ult == pl_powers[1]) then --Suicide Bomber
				msg2(id, "000255255"..pl_powers[1].." is automatic / cannot be used manually!@C")
			elseif (ult == pl_powers[3]) then --Immobile
				msg2(id, "000255255"..pl_powers[3].." is automatic / cannot be used manually!@C")
			elseif (ult == pl_powers[5]) then --Lightning Bolt
				player_shoot_lightning(id, lightning_bolt_radius)
			elseif (ult == pl_powers[7]) then --Entangle Roots
				player_entangleroots(id)
			elseif (ult == pl_powers[9]) then --Teammate Reviving
				msg2(id, "000255255"..pl_powers[9].." is automatic / cannot be used manually!@C")
			elseif (ult == pl_powers[10]) then --Flame Strike
				player_shoot_flamestrike(id, flame_strike_radius)
			elseif (ult == pl_powers[11]) then --Slow Enemy
				player_slowenemy(id)
			elseif (ult == pl_powers[13]) then --Poisonous Knife
				msg2(id, "000255255"..pl_powers[13].." is automatic / cannot be used manually!@C")
			elseif (ult == pl_powers[14]) then --Blink 
				player_blink(id, blink_radius)
			elseif (ult == pl_powers[15]) then --Carrion beetles
				player_carrionbeetles(id)
			elseif (ult == pl_powers[16]) then --Locust Swarm
				player_locustswarm(id)
			end
		end
	end
end

function player_camp_detect(id)
	if player(id, "exists") then
		--Search for env_object
		for x=1, map("xsize") do
			for y=1, map("ysize") do
				if entity(x, y, "exists") then
					if (player(id, "tilex")==x) and (player(id, "tiley")==y) then
						if entity(x, y, "typename")=="Env_Object" then--env_object
							if entity(x, y, "int0")==0 then --Palm
								return 1
							elseif entity(x, y, "int0")==1 then --Tree
								return 2
							end
						end
					end
				end
			end
		end		
	end
end

function create_building(basex, basey, position, typ, team, amount, radius, onplayer, base2x, base2y)
	local x, y
	for i=1, amount do
		if (position == 1) then
			x = math.random(basex-radius, basex+radius)
			y = math.random(basey-radius, basey+radius)
		elseif (position == 2) then
			x = math.random(1, map("xsize"))*32
			y = math.random(1, map("ysize"))*32
		end
		
		x3 = math.floor(x/32)
		y3 = math.floor(y/32)

		local proceed = 1
		
		if (onplayer == 0) then
			for k=1, max_players do
				if player(k, "exists") then
					if ((player(k, "tilex")==x3) and (player(k, "tiley")==y3)) then
						proceed = 0
					end
				end
			end
		end	

		if not entity(x3, y3, "exists") then
			if (position == 1) then
				if (proceed==1) then
					rot = 1
					parse("spawnobject "..typ.." "..x3.." "..y3.." "..rot.." 1 "..team)
				end
			elseif (position == 2) then
				if (point_collide(x, y, basex-radius, basey-radius, basex+radius, basey+radius)==0) and (point_collide(x, y, base2x-radius, base2y-radius, base2x+radius, base2y+radius)==0) then
					rot = 1
					parse("spawnobject "..typ.." "..x3.." "..y3.." "..rot.." 1 "..team)
				end			
			end
		end
	end
	
end

function create_random_base()
	
	t_base_x = 0
	t_base_y = 0
	ct_base_x = 0
	ct_base_y = 0

	--Search for T Base 
	for x=1, map("xsize") do
		for y=1, map("ysize") do
			if entity(x, y, "exists") then
				if entity(x, y, "type")==0 then--Info T
					t_base_x = x*32
					t_base_y = y*32
					break --We need just one so we end the loop
				end
			end
		end
	end

	--Search for CT Base 
	for x=1, map("xsize") do
		for y=1, map("ysize") do
			if entity(x, y, "exists") then
				if entity(x, y, "type")==1 then--Info CT
					ct_base_x = x*32
					ct_base_y = y*32
					break --We need just one so we end the loop
				end
			end
		end
	end

	
	create_building(t_base_x, t_base_y, 1, 8, 1, 8, 250, 0, ct_base_x, ct_base_y) --T Turrets
	create_building(ct_base_x, ct_base_y, 1, 8, 2, 8, 250, 0, t_base_x, t_base_y) --CT Turrets

	create_building(t_base_x, t_base_y, 1, 7, 1, 5, 180, 0, ct_base_x, ct_base_y) --T Dispensers
	create_building(ct_base_x, ct_base_y, 1, 7, 2, 5, 180, 0, t_base_x, t_base_y) --CT Dispensers

	create_building(t_base_x, t_base_y, 1, 9, 1, 5, 96, 0, ct_base_x, ct_base_y) --T Supplies
	create_building(ct_base_x, ct_base_y, 1, 9, 2, 5, 96, 0, t_base_x, t_base_y) --CT Supplies

	create_building(t_base_x, t_base_y, 1, 6, 1, 25, 400, 1, ct_base_x, ct_base_y) --T Gate fields
	create_building(ct_base_x, ct_base_y, 1, 6, 2, 25, 400, 1, t_base_x, t_base_y) --CT Gate fields

	create_building(ct_base_x, ct_base_y, 2, math.random(3, 5), 0, 400, 400, 0, t_base_x, t_base_y) --Neutral walls
end


function menu_ultimate(id)
	if (player(id, "team")>0) and (player(id, "health")>0) then
		if (pl_class[id]>0) then
			max_ultimates = 0
			ultimate_menu_content = ""
			for i=1, 2 do
				if (pl_powers[pl_class[id]*2-2+i]~="") then
					max_ultimates = max_ultimates + 1
				end
			end
			
			for i=1, max_ultimates do
				if (i<max_ultimates) then
					ultimate_menu_content = ultimate_menu_content..""..pl_powers[pl_class[id]*2-2+i].."|".."Ultimate"..", "
				else
					ultimate_menu_content = ultimate_menu_content..""..pl_powers[pl_class[id]*2-2+i].."|".."Ultimate"
				end
			end
			
			menu(id, "Ultimate menu, "..ultimate_menu_content)
		else
			msg2(id, "255000000You have to select a class!@C")
		end
	end
end

function player_reset(id)
	
	pl_clawsofattack[id]=0
	pl_maskofdeath[id]=0
	pl_orboffrost[id]=0
	pl_scrollofrespawning[id]=0
	pl_flaminggloves[id]=0
	pl_getmole[id]=0
	pl_locustswarm[id]=0
	pl_carrionbeetles[id]=0
	pl_lightning[id]=0
	pl_gotentangleroots[id]=0
	pl_entangleroots[id]=0
	pl_slowenemy[id]=0
	pl_randomclass[id]=0
	pl_ringofregeneration[id]=0
	pl_flamestrike[id]=0
	
end

function player_bot_buy(id)
	if (player(id, "exists")) then
		if (player(id, "bot")) then
			if (player(id, "health") > 0) then
				money = player(id, "money")
				--pl_items_money = {"200", "400", "500", "700", "500", "1000", "2000", "4000", "16000", "5000", "2000"}
				for k=1, math.random(3, 7) do --Buy 3 - 7 items
					buyitem = math.random(1, get_pairs(pl_items))
					if ( money >= tonumber(pl_items_money[buyitem])) then
						player_buy_item(id, buyitem)
					end
				end
			end
		end
	end
end

function colorful_text(text)
     r = ""
     g = ""
     b = ""
     final = ""
     local lol2 = initArray(3)

     for w in string.gmatch(text, "%w") do
	

	for i=1, 3 do
		lol2[i] = tostring(math.random(0, 255))
		if (string.len(lol2[i]) ~= 3) then
			if (string.len(lol2[i])==2) then
				lol2[i] = "0"..lol2[i]
			elseif (string.len(lol2[i])==1) then
				lol2[i] = "00"..lol2[i]
			end
		end
		
	end

	msg(""..lol2[1]..lol2[2]..lol2[3]..w)
     end	
end

function player_point_radius(id, x, y, radius)
	if player(id, "exists") then
		if player(id, "tilex")>=(x-radius) then
			if player(id, "tiley")>=(y-radius) then
				if player(id, "tilex")<=x+radius then
					if player(id, "tiley")<=y+radius then
						return 1
					end
				end
			end
		end
	end
	return 0
end


function player_buyzone(id)
	if player(id, "exists") then
		if player(id, "health")>0 then
			if player(id, "team")>0 then
				--Terrorists
				if player(id, "team")==1 then 
					for x=1, map("xsize") do
						for y=1, map("ysize") do
							if entity(x, y, "exists") then
								if entity(x, y, "type")==0 then --info_t
									if player_point_radius(id, x, y, 2)==1 then
										return 1
									end
								end
							end
						end
					end
				elseif player(id, "team")==2 then --Counter-Terrorists
					for x=1, map("xsize") do
						for y=1, map("ysize") do
							if entity(x, y, "exists") then
								if entity(x, y, "type")==1 then --info_ct
									if player_point_radius(id, x, y, 2)==1 then
										return 1
									end
								end
							end
						end
					end					
				end
			end
		end
	end
	return 0
end

function search_in_table(array, what)
	for i=1, get_pairs(array) do
		if (array[i]==what) then
			return 1
		end
	end
end

function player_buy_item(id, item)
	if player(id, "exists") then
		if (player(id, "health")>0) then
			if (item>=1 and item<=12) then
				if player_buyzone(id)==1 then
					--Boots of Speed
					if (item==1) then
						if (player(id, "speedmod") ~= 5) then
							if (player(id, "money")>=tonumber(pl_items_money[item])) then
								if (pl_entangleroots[id]==0 and pl_immobile[id]==0) then
									parse("speedmod "..id.." 5")
									parse("setmoney "..id.." "..player(id, "money")-tonumber(pl_items_money[item]))
									msg2(id, "000255000You have successfully bought "..pl_items[item].."!@C")
								else
									msg2(id, "255000000You cannot buy this item right now!")
								end
							else
								msg2(id, "255000000Not enough coins to buy this item! Required: "..tonumber(pl_items_money[item]).."@C")
							end
						else
							msg2(id, "255000000You are already speeded!@C")
						end
					--Claws of Attack
					elseif (item==2) then
						if (pl_clawsofattack[id]==0) then
							if (player(id, "money")>=tonumber(pl_items_money[item])) then
								pl_clawsofattack[id]=1
								parse("setmoney "..id.." "..player(id, "money")-tonumber(pl_items_money[item]))
								msg2(id, "000255000You have successfully bought "..pl_items[item].."!@C")
							else
								msg2(id, "255000000Not enough coins to buy this item! Required: "..tonumber(pl_items_money[item]).."@C")
							end
						else
							msg2(id, "255000000You already own this item!@C")
						end	
					--Cloak of Shadows
					elseif (item==3) then
						wpns = playerweapons(id)
						if (search_in_table(wpns, 84)~=1) then
							if (player(id, "money")>=tonumber(pl_items_money[item])) then
								parse("equip "..id.." 84")
								parse("setmoney "..id.." "..player(id, "money")-tonumber(pl_items_money[item]))
								msg2(id, "000255000You have successfully bought "..pl_items[item].."!@C")
							else
								msg2(id, "255000000Not enough coins to buy this item! Required: "..tonumber(pl_items_money[item]).."@C")
							end
						else
							msg2(id, "255000000You already own this item!@C")
						end	
					--Mask of Death
					elseif (item==4) then
						
						if (pl_class[id]==4) or (pl_class[id]==8) then
							msg2(id, "255100100You cannot buy this item as "..pl_classes[pl_class[id]].."!")
						else
							if (pl_maskofdeath[id]==0) then
								if (player(id, "money")>=tonumber(pl_items_money[item])) then
									pl_maskofdeath[id]=1
									parse("setmoney "..id.." "..player(id, "money")-tonumber(pl_items_money[item]))
									msg2(id, "000255000You have successfully bought "..pl_items[item].."!@C")
								else
									msg2(id, "255000000Not enough coins to buy this item! Required: "..tonumber(pl_items_money[item]).."@C")
								end
							else
								msg2(id, "255000000You already own this item!@C")
							end
						end	
					--Orb of Frost
					elseif (item==5) then
						if (pl_orboffrost[id]==0) then
							if (player(id, "money")>=tonumber(pl_items_money[item])) then
								pl_orboffrost[id]=1
								parse("setmoney "..id.." "..player(id, "money")-tonumber(pl_items_money[item]))
								msg2(id, "000255000You have successfully bought "..pl_items[item].."!@C")
							else
								msg2(id, "255000000Not enough coins to buy this item! Required: "..tonumber(pl_items_money[item]).."@C")
							end
						else
							msg2(id, "255000000You already own this item!@C")
						end	
					--Periapt of Health
					elseif (item==6) then
						if (player(id, "health") ~= player(id, "maxhealth")) then
							if (player(id, "money")>=tonumber(pl_items_money[item])) then
								parse("setmaxhealth "..id.." 150")
								parse("sethealth "..id.." 150")
								parse("setmoney "..id.." "..player(id, "money")-tonumber(pl_items_money[item]))
								msg2(id, "000255000You have successfully bought "..pl_items[item].."!@C")
							else
								msg2(id, "255000000Not enough coins to buy this item! Required: "..tonumber(pl_items_money[item]).."@C")
							end
						else
							msg2(id, "255000000You already have full health!@C")
						end
					--Scroll of Respawning
					elseif (item==7) then
						if (pl_scrollofrespawning[id]==0) then
							if (player(id, "money")>=tonumber(pl_items_money[item])) then
								pl_scrollofrespawning[id]=1
								parse("setmoney "..id.." "..player(id, "money")-tonumber(pl_items_money[item]))
								msg2(id, "000255000You have successfully bought "..pl_items[item].."!@C")
							else
								msg2(id, "255000000Not enough coins to buy this item! Required: "..tonumber(pl_items_money[item]).."@C")
							end
						else
							msg2(id, "255000000You already own this item!@C")	
						end	
					--Flaming Gloves of Warmth
					elseif (item==8) then
						if (pl_flaminggloves[id]==0) then
							if (player(id, "money")>=tonumber(pl_items_money[item])) then
								pl_flaminggloves2[id]=1
								pl_flaminggloves[id]=1
								parse("setmoney "..id.." "..player(id, "money")-tonumber(pl_items_money[item]))
								msg2(id, "000255000You have successfully bought "..pl_items[item].."!@C")
							else
								msg2(id, "255000000Not enough coins to buy this item! Required: "..tonumber(pl_items_money[item]).."@C")
							end
						else
							msg2(id, "255000000You already own this item!@C")	
						end
					--Mole
					elseif (item==9) then
						if (player(id, "money")>=tonumber(pl_items_money[item])) then
							
							local bought = 0
							
								parse("sethealth "..id.." 100")
								local enemy = 0
								for l=1, max_players do
									if player(l, "exists") then
										if (player(l, "health") > 0) then
											if (player(l, "team")>0) then
												if (player(l, "team")~=player(id, "team")) then
													--Our enemies
													enemy = enemy + 1
												end
											end
										end
									end
								end

								if (enemy > 0) then --At least one enemy
									enemyid = math.random(1, max_players)
						
									while (not(player(enemyid, "exists")) or (player(enemyid, "team")==player(id, "team")) or (player(enemyid, "team")==0) or (player(enemyid, "health")<1)) do
										enemyid = math.random(1, max_players)
									end

									enemyid_x = player(enemyid, "x")					
									enemyid_y = player(enemyid, "y")
								
									parse("setpos "..id.." "..enemyid_x.." "..enemyid_y) --Mole
									bought = 1
								end

							if bought==1 then
								parse("setmoney "..id.." "..player(id, "money")-tonumber(pl_items_money[item]))
								msg2(id, "000255000You have successfully bought "..pl_items[item].."!@C")
							else
								msg2(id, "255000000Not available!@C")
							end
						else
							msg2(id, "255000000Not enough money to buy this item! Required: "..tonumber(pl_items_money[item]).."@C")
						end
					--Tome of experience
					elseif (item==10) then
						if (player(id, "money")>=tonumber(pl_items_money[item])) then
							player_experience(id, 1, tome_of_experience_addxp)
							parse("setmoney "..id.." "..player(id, "money")-tonumber(pl_items_money[item]))
							msg2(id, "000255000You have successfully bought additional "..tome_of_experience_addxp.." xp!@C")
						else
							msg2(id, "255000000Not enough coins to buy this item! Required: "..tonumber(pl_items_money[item]).."@C")
						end		
					elseif (item==11) then
						if not(pl_class[id]==6) then
							if (player(id, "money")>=tonumber(pl_items_money[item])) then
								if pl_ringofregeneration[id]<5 then
									pl_ringofregeneration[id] = pl_ringofregeneration[id] + 1
									parse("setmoney "..id.." "..player(id, "money")-tonumber(pl_items_money[item]))
									msg2(id, "000255000You have successfully bought "..pl_items[item].."! "..pl_ringofregeneration[id].."/5@C")
								end
							else
								msg2(id, "255000000Not enough coins to buy this item! Required: "..tonumber(pl_items_money[item]).."@C")
							end		
						else
							msg2(id, "255100100You cannot buy this item as Shadow Hunter!@C")
						end
					elseif (item==12) then
						if (pl_necklaceofimmunity[id] == 0) then
							if (player(id, "money")>=tonumber(pl_items_money[item])) then
								pl_necklaceofimmunity[id] = 1
								parse("setmoney "..id.." "..player(id, "money")-tonumber(pl_items_money[item]))
								msg2(id, "000255000You have successfully bought "..pl_items[item].."!@C")								
								msg(col(255, 255, 0).."Beware, "..player(id, "name").." is now immune to all enemy ultimates!@C")
							else
								msg2(id, "255000000Not enough money to buy this item! Required: "..tonumber(pl_items_money[item]).."@C")								
							end	
						else
							msg2(id, "255000000You already own this item!@C")	
						end
					end
				else
					msg2(id, "255000000You need to be in a buy zone!@C")
				end
			end
		end
	end
end

function player_slay(id)
	if player(id, "exists") then
		if (player(id, "health") > 0) then
			parse("killplayer "..id)
			msg("Player #"..id.." has been slayed!")
			parse("sv_sound "..sound_path.."lightningbolt.ogg")
		end
	end
end


function player_select_class(id, class)
	if player(id, "exists") then
		if (class~=nil) then
			if (class>=1 and class<=8) then
				if player(id, "health")>0 then
					pl_randomclass[id] = 0
					msg2(id, "000255000Your class will be changed to "..pl_classes[class].." after your next spawn!")
					pl_nextclass[id] = class		
					-- Kill for selecting a class... NO! Wait for next round :P
					-- parse("killplayer "..id)
				else
					pl_randomclass[id] = 0
					pl_class[id] = class					
				end
			elseif (class==9) then
				if player(id, "health")>0 then
					--pl_class[id] = 9
					pl_randomclass[id] = 1
				
					-- Kill for selecting a class...
					--parse("killplayer "..id)
					msg2(id, "000255000You'll spawn next round with a random class.")
				else
					pl_class[id] = 9
					pl_randomclass[id] = 1
				end				
			end
		end
	end
	hud_pl_update(id)
end

function player_check_radius(id, id2, radius)
	if player(id, "exists") then
		if player(id, "health") > 0 then
			if player(id2, "exists") then
				if player(id2, "health")>0 then
					if (player(id2, "tilex") >= (player(id, "tilex")-radius)) then
						if (player(id2, "tiley") >= (player(id, "tiley")-radius)) then
							if (player(id2, "tilex") <= (player(id, "tilex")+radius)) then
								if (player(id2, "tiley") <= (player(id, "tiley")+radius)) then
									if (player(id2, "team")~=player(id, "team")) then
										return 2
									end
								end
							end
						end
					end
			
				end
			end
		end		
	end
end

function player_takehp(victim, shooter, amount, weapon, superpower, typ)
	if (player(victim, "exists") and player(shooter, "exists")) then
		if (typ==1) then
			if (player(victim, "health") > 0) and (player(shooter, "health") > 0) then
				if (player(victim, "health") > amount) then
					parse("sethealth "..victim.." "..player(victim, "health")-amount)
				else
					if (weapon ~= nil) then
						parse('customkill '..shooter..' "'..weapon..'" '..victim)
						if (superpower == 1) then player_experience(shooter, 1, 20) end --Get additional XP for killing with Ultimate/Super Power
					end			
				end
			end
		elseif (typ==2) then
			if (player(victim, "health") > 0) then
				if (player(victim, "health") > amount) then
					parse("sethealth "..victim.." "..player(victim, "health")-amount)
				else
					if (weapon ~= nil) then
						parse('customkill '..shooter..' "'..weapon..'" '..victim)
						if (superpower == 1) then player_experience(shooter, 1, 20) end --Get additional XP for killing with Ultimate/Super Power
					end			
				end
			end			
		end	
	end
end

function player_shoot_lightning(id, radius)
	local shock = 0
	if player(id, "exists") then
		if player(id, "health") > 0 then
			if (pl_class[id]==3) then
				if (pl_level[id]>=unlock_lightning_level) then
					if (pl_allow_ultimates[id]==1) then
						if (pl_lightning[id]==0) then
							for k=1, max_players do
								if player(k, "exists") then
									if player(k, "health")>0 then
										if (player(k, "tilex") >= (player(id, "tilex")-radius)) then
											if (player(k, "tiley") >= (player(id, "tiley")-radius)) then
												if (player(k, "tilex") <= (player(id, "tilex")+radius)) then
													if (player(k, "tiley") <= (player(id, "tiley")+radius)) then
														if (player(k, "team")~=player(id, "team")) then
															if (pl_necklaceofimmunity[k] == 0) then
																msg(col(255, 255, 255)..player(k, "name").." got shocked! (by "..player(id, "name")..")")
																player_takehp(k, id, 85, "Lightning Bolt", 1, 1)
															else
																msg(col(0, 255, 255)..player(k, "name").." is immune to Lightning Bolts!")
															end	
															shock = 1
														end
													end
												end
											end
										end
									end
								end
							end
							if (shock==0) then msg("255255255"..player(id, "name")..": No target!@C") end
							parse("sv_sound "..sound_path.."lightningbolt.ogg")
							if (shock==1) then parse("sv_sound "..sound_path.."shock.ogg") end
							pl_lightning[id]=1
						else
							msg2(id, "255000000You are out of lightning bolts!")
						end
					else
						msg2(id, col(255, 0, 0).."All of your Ultimates are disabled!@C")
					end
				else
					msg2(id, "255000000You can't use this ultimate until level "..unlock_lightning_level.."!@C")
				end
			else
				msg2(id, "255000000You need to be Orcish Horde to shoot Lightning bolts!")
			end
		end
	end
end

function player_strip_all(id)
	strip = playerweapons(id)
	count = get_pairs(strip)
	
	for i=1, count do
		parse("strip "..id.." "..strip[i])
	end
end

function player_blink(id, radius)
	local blink = 0
	if player(id, "exists") then
		if player(id, "health") > 0 then
			--Warden
			if (pl_class[id]==7) then
				if (pl_level[id]>=unlock_blink_level) then
					if (pl_allow_ultimates[id]==1) then
						if (pl_blink[id]==0) then

							for k=1, max_players do
								if player(k, "exists") then
									if player(k, "health")>0 then
										if (player(k, "tilex") >= (player(id, "tilex")-radius)) then
											if (player(k, "tiley") >= (player(id, "tiley")-radius)) then
												if (player(k, "tilex") <= (player(id, "tilex")+radius)) then
													if (player(k, "tiley") <= (player(id, "tiley")+radius)) then
														if (player(k, "team")~=player(id, "team")) then
															if (pl_necklaceofimmunity[k] == 0) then
																msg(col(255, 0, 255)..player(k, "name").." has been blinked! (by "..player(id, "name")..")")
																player_strip_all(k)
																player_takehp(k, id, 10, "Blink", 1, 1)
															else
																msg(col(0, 255, 255)..player(k, "name").." is immune to Blinks!")
															end
															blink = 1
														end
													end
												end
											end
										end
									end
								end
							end
							if (blink==0) then msg("255000255"..player(id, "name")..": No target!@C") end
							parse("sv_sound "..sound_path.."blink.ogg")
							--if (blink==1) then parse("sv_sound "..sound_path.."blink.ogg") end
							pl_blink[id]=1
						else
							msg2(id, "255000000You have already used a Blink!")
						end
					else
						msg2(id, col(255, 0, 0).."All of your Ultimates are disabled!@C")
					end
				else
					msg2(id, "255000000You can't use this ultimate until level "..unlock_blink_level.."!@C")
				end
			else
				msg2(id, "255000000You need to be Warden to perform a Blink!")
			end
		end
	end
end

function player_shoot_flamestrike(id, radius)
	local flamed = 0
	if player(id, "exists") then
		if player(id, "health") > 0 then
			if (pl_class[id]==5) then
				if (pl_level[id]>=unlock_flame_strike_level) then
					if (pl_allow_ultimates[id]==1) then
						if (pl_flamestrike[id]==0) then
							for k=1, max_players do
								if player(k, "exists") then
									if player(k, "health")>0 then
										if (player(k, "tilex") >= (player(id, "tilex")-radius)) then
											if (player(k, "tiley") >= (player(id, "tiley")-radius)) then
												if (player(k, "tilex") <= (player(id, "tilex")+radius)) then
													if (player(k, "tiley") <= (player(id, "tiley")+radius)) then
														if (player(k, "team")~=player(id, "team")) then
															if pl_flamed[k]==0 then
																if (pl_necklaceofimmunity[k] == 0) then
																	pl_flamed[k]=1
																	pl_flamed_owner[k]=id
																	msg(col(255, 194, 14)..player(k, "name").." has been set on fire! (by "..player(id, "name")..")")
																else
																	msg(col(0, 255, 255)..player(k, "name").." is immune to Flame Strikes!")
																end
																flamed = 1
															end
														end
													end
												end
											end
										end
									end
								end
							end
							if (flamed==0) then msg("255194014"..player(id, "name")..": No target!@C") end
							parse("sv_sound "..sound_path.."flame_strike.ogg")
							--if (poisoned=1) then parse("sv_sound "..sound_path.."flamed.ogg") end
							pl_flamestrike[id]=1
						else
							msg2(id, "255000000You can't use Flame Strike again!")
						end
					else
						msg2(id, col(255, 0, 0).."All of your Ultimates are disabled!@C")
					end
				else
					msg2(id, "255000000You can't use this ultimate until level "..unlock_flame_strike_level.."!@C")
				end
			else
				msg2(id, "255000000You need to be Blood Mage to create Flame Strike!")
			end
		end
	end
end

function random_col()
	r = ""
	g = ""
	b = ""
	final = ""
	local lol2 = initArray(3)
	
	for i=1, 3 do
		lol2[i] = tostring(math.random(0, 255))
		if (string.len(lol2[i]) ~= 3) then
			if (string.len(lol2[i])==2) then
				lol2[i] = "0"..lol2[i]
			elseif (string.len(lol2[i])==1) then
				lol2[i] = "00"..lol2[i]
			end
		end
		final = final..lol2[i]	
	end
	return final

end

function player_locustswarm(id)
		if (player(id, "health")>0) then
			if (pl_class[id]==8) then
				if (pl_level[id]>=unlock_locust_swarm_level) then
					if (pl_allow_ultimates[id]==1) then
						if (pl_locustswarm[id]==0) then
							local enemy = 0
							for l=1, max_players do
								if player(l, "exists") then
									if (player(l, "health") > 0) then
										if (l~=id) then
											if (player(l, "team")>0) then
												if (player(l, "team")~=player(id, "team")) then
													--Our enemies
													enemy = enemy + 1
												end
											end
										end
									end
								end
							end

							if (enemy > 0) then --At least one enemy
								if (math.random(1, 100)<=locust_swarm_deploy_chance) then
									enemyid = math.random(1, max_players)
									
									while (not(player(enemyid, "exists")) or (player(enemyid, "team")==player(id, "team")) or (player(enemyid, "health")<1) or (player(enemyid, "team")==0)) do
										enemyid = math.random(1, max_players)
									end							
									
									if (pl_necklaceofimmunity[enemyid] == 0) then									
										msg(col(0, 255, 0)..player(id, "name").."'s used Locust Swarm on "..player(enemyid, "name").."!")
										player_takehp(enemyid, id,locust_swarm_damage, "Locust Swarm", 1, 1)
									else
										msg(col(0, 255, 255)..player(id, "name").."'s used Locust Swarm on "..player(enemyid, "name").."! However, he is immune to it!")
									end	
									parse("sv_sound "..sound_path.."locustswarm.ogg")
									pl_locustswarm[id]=1
								else
									msg2(id, "255000000The delivery has failed! Try luck next round.")
								end
							else
								msg2(id, "255000000Not available!@C")
							end

						else
							msg2(id, "255000000You have already used Locust Swarm!@C")
						end
					else
						msg2(id, col(255, 0, 0).."All of your Ultimates are disabled!@C")
					end							
				else
					msg2(id, "255000000You can't use this ultimate until level "..unlock_locust_swarm_level.."!@C")
				end
			else
				msg2(id, "255000000You need to be Crypt Lord to perform Locust Swarm attack!@C")
			end
		end
end

function player_entangleroots(id)
		if (player(id, "health")>0) then
			if (pl_class[id]==4) then
				if (pl_level[id]>=unlock_entangle_roots_level) then
					if (pl_allow_ultimates[id]==1) then
						if (pl_gotentangleroots[id]==0) then
							local enemy = 0
							for l=1, max_players do
								if player(l, "exists") then
									if (player(l, "health") > 0) then
										if (l~=id) then
											if (player(l, "team")~=player(id, "team")) then
												--Our enemies
												enemy = enemy + 1
											end
										end
									end
								end
							end
							
							if (enemy > 0) then --At least one enemy
								if (math.random(1, 100)<=entangle_roots_deploy_chance) then
									enemyid = math.random(1, max_players)
									
									while (not(player(enemyid, "exists")) or (player(enemyid, "team")==player(id, "team")) or (player(enemyid, "health")<1) or (player(enemyid, "team")==0)) do
										enemyid = math.random(1, max_players)
									end							
									
									if (pl_necklaceofimmunity[enemyid] == 0) then
										pl_entangleroots[enemyid]=1
										msg(col(0, 255, 0)..player(id, "name").."'s used Entangle Roots on "..player(enemyid, "name").."! He can't move for "..player_entangle_roots_time.." seconds.")
									else
										msg(col(0, 255, 255)..player(id, "name").."'s used Entangle Roots on "..player(enemyid, "name").."! However, he is immunte to it!")										
									end
									
									parse("sv_sound "..sound_path.."entangleroots.ogg")
									pl_gotentangleroots[id]=1
								else
									msg2(id, "255000000The delivery has failed! Try luck next round.")
									pl_gotentangleroots[id]=1
								end
							else
								msg2(id, "255000000Not available!@C")
							end
							
						else
							msg2(id, "255000000You have already used Entangle Roots!")	
						end
					else
						msg2(id, col(255, 0, 0).."All of your Ultimates are disabled!@C")
					end							
				else
					msg2(id, "255000000You can't use this ultimate until level "..unlock_entangle_roots_level.."!@C")				
				end
			else
				msg2(id, "255000000You need to be Night Elf of Kalimdore to perform Entangle Roots.")
			end
		end
end

function player_slowenemy(id)
		if (player(id, "health")>0) then
			if (pl_class[id]==6) then
				if (pl_level[id]>=unlock_slow_enemy_level) then
					if (pl_allow_ultimates[id] == 1) then
						if (pl_slowenemy[id]==0) then
							pl_slowenemy[id]=1

							local enemy = 0
							for l=1, max_players do
								if player(l, "exists") then
									if (player(l, "health") > 0) then
										if (player(l, "team")>0) then
											if (player(l, "team")~=player(id, "team")) then
												--Our enemies
												enemy = enemy + 1
											end
										end
									end
								end
							end
							
							if (enemy > 0) then --At least one enemy
								if (math.random(1, 100)<=slow_enemy_deploy_chance) then
									enemyid = math.random(1, max_players)
									
									while (not(player(enemyid, "exists")) or (player(enemyid, "team")==player(id, "team")) or (player(enemyid, "health")<1) or (player(enemyid, "team")==0)) do
										enemyid = math.random(1, max_players)
									end	
									if (pl_necklaceofimmunity[enemyid] == 0) then
										parse("speedmod "..enemyid.." -10") --Mole
										msg("000255000"..player(id, "name").."'s used Slow Enemy on "..player(enemyid, "name").."!")
									else
										msg("000000255"..player(id, "name").."'s used Slow Enemy on "..player(enemyid, "name").."! However, he is immune to it!")
									end
									parse("sv_sound "..sound_path.."slowenemy.ogg")
									pl_slowenemy[id]=1
								else
									msg2(id, "255000000The delivery has failed! Try luck next round.")
									pl_slowenemy[id]=1
								end
							else
								msg2(id, "255000000Not available!@C")
							end	
						else
							msg2(id, "255000000You have already used Slow enemy!")				
						end
					else
						msg2(id, col(255, 0, 0).."All of your Ultimates are disabled!@C")
					end	
				else
					msg2(id, "255000000You can't use this ultimate until level "..unlock_slow_enemy_level.."!@C")
				end
			else
				msg2(id, "255000000You need to be Shadow Hunter to perform Slowing Enemy!")
			end
		end
end

function player_carrionbeetles(id)
		if (player(id, "health")>0) then
			if (pl_class[id]==8) then
				if (pl_level[id]>=unlock_carrion_beetles_level) then
					if (pl_allow_ultimates[id]==1) then
						if (pl_carrionbeetles[id]==0) then 
							local enemy = 0
							for l=1, max_players do
								if player(l, "exists") then
									if (player(l, "health") > 0) then
										if (player(l, "team")>0) then
											if (player(l, "team")~=player(id, "team")) then
												--Our enemies
												enemy = enemy + 1
											end
										end
									end
								end
							end
							
							if (enemy > 0) then --At least one enemy
								if (math.random(1, 100)<=carrion_beetles_deploy_chance) then
									enemyid = math.random(1, max_players)
									
									while ((not(player(enemyid, "exists"))) or (player(enemyid, "team")==player(id, "team")) or (player(enemyid, "health")<1) or (player(enemyid, "team")==0)) do
										enemyid = math.random(1, max_players)
									end	
									
									if (pl_necklaceofimmunity[enemyid] == 0) then
										player_takehp(enemyid, id,carrion_beetles_damage, "Carrion Beetles", 1, 1)
										msg(col(0, 255, 0)..player(id, "name").."'s used Carrion Beetles on "..player(enemyid, "name").."!")
										if (math.random(1, 100)<=carrion_beetles_poison_chance) then
											pl_poisoned[enemyid] = 1; pl_poisoned_owner[enemyid] = id
											msg(col(255, 100, 20)..player(enemyid, "name").." is poisoned!")
										end
									else
										msg(col(0, 255, 255)..player(id, "name").."'s used Carrion Beetles on "..player(enemyid, "name").."! However, he is immune to it!")
									end
									parse("sv_sound "..sound_path.."carrionswarm.ogg")
									pl_carrionbeetles[id]=1
								else
									msg2(id, "255000000The delivery has failed! Try luck next round.")
									pl_carrionbeetles[id]=1
								end
							else
								msg2(id, "255000000Not available!@C")
							end
						else
							msg2(id, "255000000You have already used Carrion Beetles!@C")
						end
					else
						msg2(id, col(255, 0, 0).."All of your Ultimates are disabled!@C")
					end							
				else					
					msg2(id, "255000000You can't use this ultimate until level "..unlock_carrion_beetles_level.."!@C")
				end
			else
				msg2(id, "255000000You need to be Crypt Lord to perform Carrion Beetles attack!@C")
			end
		end
end

function player_experience(id, plus, amount)
	if player(id, "exists") then
		if (plus==1) then
			if (pl_level[id]<7) then pl_xp[id] = pl_xp[id] + amount end
			if pl_xp[id]>=pl_maxxp[id] then
				if (pl_level[id]<7) then
					parse("sv_sound wc3tft_2d/levelup.ogg")
					pl_level[id]=pl_level[id]+1
					
					if (pl_level[id]==unlock_immobiling_level) then msg2(id, "050020255Unlocked Immobiling for Human Alliance!@C") end
					if (pl_level[id]==unlock_suicide_bomber_level) then msg2(id, "050020255Unlocked Suicide Bomber for Undead Scourge!@C") end
					if (pl_level[id]==unlock_poisonous_knife_level) then msg2(id, "050020255Unlocked Poisonous Knife for Warden!@C") end
					if (pl_level[id]==unlock_teammate_revealing_level) then msg2(id, "050020255Unlocked Teammate Revealing for Blood Mage!@C") end
					if (pl_level[id]==unlock_slow_enemy_level) then	msg2(id, "050020255Unlocked Slow Enemy for Shadow Hunter!@C") end
					if (pl_level[id]==unlock_entangle_roots_level) then msg2(id, "050020255Unlocked Entangle Roots for Night Elf of Kalimdore!@C") end
					if (pl_level[id]==unlock_lightning_level) then msg2(id, "050020255Unlocked Lightning for Orcish Horde!@C") end
					if (pl_level[id]==unlock_carrion_beetles_level) then msg2(id, "050020255Unlocked Carrion Beetles for Crypt Lord!@C") end
					if (pl_level[id]==unlock_locust_swarm_level) then msg2(id, "050020255Unlocked Locust Swarm for Crypt Lord!@C") end
					if (pl_level[id]==unlock_flame_strike_level) then msg2(id, "050020255Unlocked Flame Strike for Blood Mage!@C") end
					if (pl_level[id]==unlock_blink_level) then msg2(id, "050020255Unlocked Blink for Warden!@C") end
					if (pl_level[id]==7) then msg2(id, "255255100You are last level and start with 16000 money every round!@C") end
					
					if (pl_level[id]==7) then
						msg("100255050"..player(id, "name").." has reached the final level 7! Congratulations!")
						msg2(id, "You can reset your status by writing !reset!")
						pl_xp[id]=1337
						pl_maxxp[id]=1337
					else
						msg("000255000"..player(id, "name").." has gained a new level (current: "..pl_level[id]..")!")
						pl_xp[id]=0
						pl_maxxp[id]=pl_maxxp[id]*2					
					end
				end
			end
		else
			
			pl_xp[id] = pl_xp[id] - amount
			if (pl_level[id] == 1) then
				if (pl_xp[id]<0) then pl_xp[id]=0 end
			end
			
			if pl_xp[id]<0 then
				if pl_level[id]>1 then
					pl_level[id]=pl_level[id]-1
					pl_xp[id]=0
					pl_maxxp[id]=pl_maxxp[id]/2
				end
			end
			
		end
		hud_pl_update(id)
		save_settings(id)
	end
end

function player_reset_xp(id)
	if (player(id, "exists")) then
		if (pl_level[id]>=7) then
			pl_xp[id]=0
			pl_maxxp[id]=20
			pl_level[id]=1
			save_settings(id)
			msg2(id, "000200000Your settings have been successfully reseted!")
			hud_pl_update(id)
		else
			msg2(id, "255000000You haven't reached the final level yet!")
		end
	end
end

function player_respawn(id, x, y)
	if player(id, "exists") then
		parse("spawnplayer "..id.." "..x.." "..y)
		if (pl_randomclass[id] == 1) then
			pl_class[id]=math.random(1, 8)
		end		
		parse("equip "..id.." 50")
		parse("sv_sound "..sound_path.."reincarnation.ogg")
	end
end

function player_give_speed(id)
	if player(id, "exists") then
		parse("speedmod "..id.." 0")

		if (pl_class[id]==1) then
			parse("speedmod "..id.." 5")
		
		elseif (pl_class[id]==2) then
			-- No speed change
		elseif (pl_class[id]==3) then
			-- No speed change
		elseif (pl_class[id]==4) then
			-- No speed change
		elseif (pl_class[id]==5) then
			-- No speed change
		elseif (pl_class[id]==6) then
			-- No speed change
		elseif (pl_class[id]==7) then
			-- No speed change
		elseif (pl_class[id]==8) then
			-- No speed change
		elseif (pl_class[id]==9) then
			-- No speed change
		elseif (pl_class[id]==10) then
			-- No speed change
		end
	
	end
end
